; ********************************************************************
;File: PTypesDlg.asm
;Proj: PhoneList
;
;Desc: Dialog procedures
;
;Author: Brian Algeri <bdasp@hotmail.com>
;Created: 7/26/2005 
;Revisons: darc version control
;Editor: MicroEmacs
;Build: Build.bat
;Runtime: Win32,sqlite.dll
;
;Type: GoAsm file
; ********************************************************************

#include "WndDef.inc"

.data

hPtDlg dd 0
hList dd 0

; ********************************************************************

.const

PTYPEMSGS
dd WM_INITDIALOG,PtINIT
dd WM_CLOSE,PtCLOSE
dd WM_COMMAND,PtCOMMAND 

; ********************************************************************

.code

PhoneTypesDlgTable:
mov ecx,sizeof PTYPEMSGS/8
mov edx,addr PTYPEMSGS
call GenDlgProc
ret 10h

; --------------------------------------------------------------------

PtINIT:
mov eax,D[ebp+08h]
mov D[hPtDlg],eax

push 3005,[hPtDlg]   ;3005=IDC_LISTPTYPES
call GetDlgItem
mov [hList],eax

call GetPhoneTypes
ret

; --------------------------------------------------------------------

PtCLOSE:
push 0,[ebp+08h]
call EndDialog
ret

; --------------------------------------------------------------------

PtCOMMAND:
nop
ret

; --------------------------------------------------------------------

GetPhoneTypes:
call OpenDatabase
push 0,0
push addr PhoneTypesRecSet  ;callback proc, called once for each row 
push addr dbSql3            ;SQL statement to be executed  
push [ppDb]                 ;database
call sqlite3_exec
add esp,14h
call CloseDatabase
ret;

; --------------------------------------------------------------------

PhoneTypesRecSet:
;callback proc called by sqlite3_exec,called once per returned row  
;esp+4-void
;esp+8-number of columns in result- int
;esp+0Ch-array of chars holding the values for each column- char** 
;esp+10h-array of chars holding the column names- char**
;see sqlite3.h

push ebp
mov ebp,esp

mov ecx,[ebp+10h] ;adjusted for the one push, ecx pts to a char**
add ecx,4h        ;point to the second column 
mov ecx,[ecx]     ;dereference pointer,ecx pts to a char* 

push ecx,0,180h,[hList] ;180h=LB_ADDSTRING
call SendMessageA

pop ebp
xor eax,eax
ret;

; ********************************************************************
