; ********************************************************************
;File: PhoneList.asm
;Proj: PhoneList
;
;Desc: Phone List Application
;
;Author: Brian Algeri <bdasp@hotmail.com>
;Created: 7/26/2005 
;Revisons: darc version control
;Editor: MicroEmacs
;Build: Build.bat
;Runtime: Win32,sqlite.dll
;
;Type: GoAsm file
; ********************************************************************

#include "WndDef.inc"
#include "ResDef.inc"

.Data
hInst dd 0
hWnd dd 0
hStatusBar dd 0
hListView dd 0

WNDCLASS dd 10d dup 0
MSG dd 7d dup 0
WndClassName db 'WC',0
LV_COLUMN dd 6d dup 0
LV_ITEM dd 9d dup 0

ppDb dd 0
dbFile db 'PhoneList.db',0
dbSql1 db 'SELECT * FROM V1;',0 ;View #1 - the phonelist rs
dbSql2 db 'SELECT * FROM V2;',0 ;View #2 - the persons rs
dbSql3 db 'SELECT * FROM PhoneTypes ORDER BY ptype ASC;',0
dbSql4 db 'SELECT * FROM States ORDER BY state ASC;',0

R01 db 'Last Name',0
R02 db 'First Name',0
R03 db 'Type',0
R04 db 'Phone Number',0
R05 db 'Speed Dial',0
R06 db 'Test data',0

; ********************************************************************

.Const
WNDMSGS
dd WM_CREATE,CREATE
dd WM_DESTROY,DESTROY
dd WM_COMMAND,COMMAND
dd WM_SIZE,SIZE

; ********************************************************************

.Code
start:
call InitApp
call RegWndClass 
call CreateWnd
call MsgLoop
call ExitApp 
ret

; --------------------------------------------------------------------

InitApp:
push 0
call GetModuleHandleA
mov [hInst],eax
ret

; --------------------------------------------------------------------

RegWndClass:
mov ebx, addr WNDCLASS
push IDC_ARROW,0
call LoadCursorA
mov D[ebx+18h],eax
push IDI_ICON
push [hInst]
call LoadIconA
mov D[ebx+14h],eax
mov eax,[hInst]
mov D[ebx+10h],eax
mov D[ebx+1Ch],COLOR_APPWORKSPACE
mov D[ebx+4h],addr WndProc
mov D[ebx+24h],addr WndClassName
mov D[ebx],CS_VREDRAW+CS_HREDRAW+CS_CLASSDC
push ebx
call RegisterClassA
ret

; --------------------------------------------------------------------

CreateWnd:
push SM_CXSCREEN
call GetSystemMetrics 
push eax,320d
call CalcCenter
push eax
push SM_CYSCREEN
call GetSystemMetrics
push eax,240d
call CalcCenter
mov ecx,eax
pop edx

push 0,[hInst],0,0
push 480d,640d,ecx,edx
push WS_OVERLAPPED+CAPTION+SYSMENU+MINIMIZEBOX
push 'Phone List - Unfinished Preview',Addr WndClassName
push WS_EX_OVERLAPPEDWINDOW
call CreateWindowExA
mov [hWnd],eax

push IDM_APPMENU,[hInst]
call LoadMenuA
push eax,[hWnd]
call SetMenu

push SW_SHOWNORMAL
push [hWnd]
call ShowWindow 
push [hWnd]
call UpdateWindow

call DoStatusBar
call DoListView
call GetPhoneList

push [hListView]
call SetFocus
ret

; --------------------------------------------------------------------

CalcCenter:
push ebp
mov ebp, esp
mov eax,[ebp+0Ch]
shr eax,1
mov ebx,[ebp+8h]
sub eax,ebx
pop ebp
ret 8h

; --------------------------------------------------------------------

DoStatusBar:
push 200d,[hWnd],0,WS_CHILD or WS_VISIBLE or SBS_SIZEGRIP
call CreateStatusWindowA
mov [hStatusBar], eax
push 'Ready',0,SB_SETTEXT,[hStatusBar]
call SendMessageA
ret

; --------------------------------------------------------------------

DoListView:
call InitCommonControls

;create listview        h    w    y   x
push 0,[hInst],0,[hWnd],360d,610d,20d,10d
push WS_CHILD or WS_VISIBLE or LVS_REPORT
push 0,'SysListView32',0
call CreateWindowExA
mov [hListView],eax

;create the five columns
;index 0
mov edx,addr LV_COLUMN
mov D[edx],LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM
mov D[edx+4h],LVCFMT_LEFT
mov D[edx+8h],125d
mov D[edx+0Ch],addr R01
push edx
push edx,0,LVM_INSERTCOLUMN,[hListView]
call SendMessageA

;index 1
pop edx
mov D[edx+0Ch],addr R02
push edx
push edx,1,LVM_INSERTCOLUMN,[hListView]
call SendMessageA

;index 2
pop edx
mov D[edx+8h],75d
mov D[edx+0Ch],addr R03
push edx
push edx,2,LVM_INSERTCOLUMN,[hListView]
call SendMessageA

;index 3
pop edx
mov D[edx+8h],200d
mov D[edx+0Ch],addr R04
push edx
push edx,3,LVM_INSERTCOLUMN,[hListView]
call SendMessageA

;index 4
pop edx
mov D[edx+8h],84d
mov D[edx+0Ch],addr R05
push edx,4,LVM_INSERTCOLUMN,[hListView]
call SendMessageA
ret

; --------------------------------------------------------------------

OpenDatabase:
push addr ppDb
push addr dbFile
call sqlite3_open
add esp,8h
ret

; --------------------------------------------------------------------

CloseDatabase:
push [ppDb]
call sqlite3_close
add esp,4h
ret

; --------------------------------------------------------------------

GetPhoneList:
call OpenDatabase
push 0,0
push addr PhoneListRecSet   ;callback proc, called once for each row 
push addr dbSql1            ;SQL statement to be executed  
push [ppDb]                 ;database
call sqlite3_exec
add esp,14h
call CloseDatabase
ret;

; --------------------------------------------------------------------

PhoneListRecSet:
;callback proc called by sqlite3_exec,called once per returned row  
;esp+4-void
;esp+8-number of columns in result- int
;esp+0Ch-array of chars holding the values for each column- char** 
;esp+10h-array of chars holding the column names- char**
;see sqlite3.h

push ebp
mov ebp,esp

mov ecx,[ebp+10h] ;adjusted for the ebp push, ecx pts to a char**
push ecx          ;store to access other columns
mov ecx,[ecx]     ;dereference pointer,ecx pts to a char* 

mov edx,addr LV_ITEM; or LVIF_STATE or LVIF_PARAM	 
mov D[edx],LVIF_TEXT   ;mask
mov D[edx+4h],0        ;first column as the item   
mov D[edx+8h],0        ;subitem 
mov D[edx+14h],ecx     ;ptr to the text
push edx               ;store struct to reuse
push edx,0,LVM_INSERTITEM,[hListView]
call SendMessageA

pop edx,ecx            ;retrieve stored values
add ecx,4h             ;next column
push ecx              
mov ecx,[ecx]          ;derefrence char**        
mov D[edx+8h],1        ;second column as a subitem 
mov D[edx+14h],ecx
push edx
push edx,0,LVM_SETITEM,[hListView]
call SendMessageA

pop edx,ecx
add ecx,4h
push ecx
mov ecx,[ecx]                 
mov D[edx+8h],2        ;third column as a subitem   
mov D[edx+14h],ecx
push edx
push edx,0,LVM_SETITEM,[hListView]
call SendMessageA

pop edx,ecx
add ecx,4h
push ecx
mov ecx,[ecx]                 
mov D[edx+8h],3        ;fourth column as a subitem 
mov D[edx+14h],ecx
push edx
push edx,0,LVM_SETITEM,[hListView]
call SendMessageA

pop edx,ecx
add ecx,4h
mov ecx,[ecx]                 
mov D[edx+8h],4        ;fith column as a subitem
mov D[edx+14h],ecx
push edx,0,LVM_SETITEM,[hListView]
call SendMessageA

pop ebp
xor eax,eax
ret;

; --------------------------------------------------------------------

MsgLoop:
push 0,0,0
push addr MSG
call GetMessageA
or eax,eax
jz >L1
push addr MSG
call TranslateMessage
push addr MSG
call DispatchMessageA
jmp MsgLoop
L1:
ret

; --------------------------------------------------------------------

ExitApp:
push [hInst],addr WndClassName
call UnregisterClassA
push [MSG+8h]
call ExitProcess
ret

; --------------------------------------------------------------------

CREATE:
xor eax,eax
ret

DESTROY:
push 0
call PostQuitMessage
stc
ret

COMMAND:
cmp D[ebp+10h],IDM_FILE_EXIT
jnz >:
push 0,SC_CLOSE,WM_SYSCOMMAND,[hWnd]
call SendMessageA
:
cmp D[ebp+10h],IDM_HELP_ABOUT
jnz >:
push 0,addr AboutDlgTable,[hWnd],IDD_ABOUT,[hInst]
call DialogBoxParamA
:
cmp D[ebp+10h],IDM_UTILS_PERSON
jnz >:
push 0,addr PersonsDlgTable,[hWnd],IDD_PERSONS,[hInst]
call DialogBoxParamA
:
cmp D[ebp+10h],IDM_UTILS_NUMBER
jnz >:
push 0,addr PhoneListDlgTable,[hWnd],IDD_ADDPLIST,[hInst]
call DialogBoxParamA
:
cmp D[ebp+10h],IDM_UTILS_TYPE
jnz >:
push 0,addr PhoneTypesDlgTable,[hWnd],IDD_PTYPE,[hInst]
call DialogBoxParamA
:
ret

SIZE:
push 1,0,0,0,0,[hStatusBar]
call MoveWindow
ret

; --------------------------------------------------------------------

WndProc:             ;params: hwnd,msg,wparam,lparam    
push ebp             ;ebp+    8h  ,0Ch,10h   ,14h    
mov ebp,esp
mov eax,[ebp+0Ch]
mov ecx,sizeof WNDMSGS/8
mov edx,addr WNDMSGS
L1:
dec ecx
JS >L2
cmp[edx+ecx*8],eax
jnz L1
call [edx+ecx*8+4]
jnc >L3
L2:
push [ebp+14h],[ebp+10h]
push [ebp+0Ch],[ebp+8h]
call DefWindowProcA
L3:
pop ebp
ret 10h


; ********************************************************************
